diff -ru fltk-1.3.2.orig/src/Fl_x.cxx fltk-1.3.2/src/Fl_x.cxx
--- fltk-1.3.2.orig/src/Fl_x.cxx	2012-10-16 17:35:34.000000000 +0200
+++ fltk-1.3.2/src/Fl_x.cxx	2013-09-08 13:04:43.353994000 +0200
@@ -1003,7 +1003,6 @@
     return 0;
 
   case SelectionNotify: {
-    if (!fl_selection_requestor) return 0;
     static unsigned char* buffer = 0;
     if (buffer) {XFree(buffer); buffer = 0;}
     long bytesread = 0;
@@ -1057,6 +1056,9 @@
     }
     Fl::e_text = buffer ? (char*)buffer : (char *)"";
     Fl::e_length = bytesread;
+
+    if (!fl_selection_requestor) return 1;
+
     int old_event = Fl::e_number;
     fl_selection_requestor->handle(Fl::e_number = FL_PASTE);
     Fl::e_number = old_event;
@@ -1207,6 +1209,10 @@
       event = FL_DND_ENTER;
       Fl::e_text = unknown;
       Fl::e_length = unknown_len;
+      fl_selection_requestor = Fl::belowmouse();
+      XConvertSelection(fl_display, fl_XdndSelection,
+                        fl_dnd_type, XA_SECONDARY,
+                        fl_xevent->xclient.window, fl_event_time);
       break;
 
     } else if (message == fl_XdndPosition) {
@@ -1222,8 +1228,7 @@
       fl_event_time = data[3];
       fl_dnd_source_action = data[4];
       fl_dnd_action = fl_XdndActionCopy;
-      Fl::e_text = unknown;
-      Fl::e_length = unknown_len;
+
       int accept = Fl::handle(FL_DND_DRAG, window);
       fl_sendClientMessage(data[0], fl_XdndStatus,
                            fl_xevent->xclient.window,
@@ -1236,8 +1241,6 @@
     } else if (message == fl_XdndLeave) {
       fl_dnd_source_window = 0; // don't send a finished message to it
       event = FL_DND_LEAVE;
-      Fl::e_text = unknown;
-      Fl::e_length = unknown_len;
       break;
 
     } else if (message == fl_XdndDrop) {
